#ifndef MOTOR_H
#define MOTOR_H

#include "mbed.h"
//#include "main.h"

#define BRAKE_VOLTAGE 0.2

/*
extern PwmOut left1;
extern PwmOut left2;
extern PwmOut right1;
extern PwmOut right2;

extern DigitalOut enableLeftMotor;
extern DigitalOut enableRightMotor; */

class Motor
{
    public:
        Motor( PinName f, PinName b, PinName e ) : 
            forw( f ), back( b ), enableMotor( e ), maxSpeed( 0.2 ), minSpeed(0.07)
        {
            enableMotor.write( 1 );
        }
    
        void backward( double voltage );
        void forward( double voltage );
        void brake();
        void coast();
        void move( double voltage );
        
    private:
        PwmOut forw;
        PwmOut back;
        DigitalOut enableMotor;  
        const double maxSpeed;
        const double minSpeed;
};

//QEI leftWheel(

/*
inline void enableMotors(){
    enableLeftMotor.write(1);
    enableRightMotor.write(1);
}*/


#endif